//+------------------------------------------------------------------+
//|                                     Exp-CloseIfProfitAndLoss.mq4 |
//|                                       Copyright  2009, Expforex |
//|                                            http://expforex.at.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Expforex"
#property link      "http://expforex.at.ua"
#property show_inputs
#include <stdlib.mqh>
extern bool =true;
extern double =0;
extern bool =true;
extern string a="     ";
extern double =0;
double Prof=0;
extern int slippage=0;
extern bool PrClose=false;
extern int ProcentToclose=20;

//+------------------------------------------------------------------+
double Price[2];
int    giSlippage;
bool   CloseOpenOrders = true;

void init()
{

Stamp();
start();
}

int start()
{
  if (PrClose)Comment("      ");
  if (!PrClose)Comment("    ");

  double proftockose=0;
  if (!PrClose){
 for (int cnt = 1 ; cnt <= OrdersTotal(); cnt++) 
   { 
      OrderSelect(cnt-1,SELECT_BY_POS,MODE_TRADES); 
      double OrderProf=OrderProfit();
      Prof=Prof+OrderProf;
    }     
if  (==true&&Prof>=&&Prof!=0)    
{
PlaySound("stops.wav");
while (OrdersTotal()!=0)
{
startcLOSE();
Comment("   : ", Prof, "\n  :",GetLastError());
}
Prof=0;
}

if  (==true&&Prof<&&Prof!=0)  
   {
PlaySound("stops.wav");
while (OrdersTotal()!=0)
{
startcLOSE();  
Comment("   : ", Prof, "\n  :",GetLastError());
}
}
    Prof=0;
    
    }
    
    
 //----------------------------------------------------------------------------------------
 
 
 
if (PrClose){
 for (int cnt2 = 1 ; cnt2 <= OrdersTotal(); cnt2++) 
   { 
      OrderSelect(cnt2-1,SELECT_BY_POS,MODE_TRADES); 
      double OrderProf2=OrderProfit();
      Prof=Prof+OrderProf2;
    }  
    
proftockose=(AccountBalance()/100)*ProcentToclose;      
if (Prof>=proftockose){
PlaySound("stops.wav");
while (OrdersTotal()!=0)
    {
startcLOSE();
Comment("   : ", Prof, "\n  :",GetLastError());
    }


}
Comment("   = "+Prof/(AccountBalance()/100));
Prof=0;
}   
   return(0);
  }
  








//+------------------------------------------------------------------+

void CloseOrder()
{
for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //     
        { 
        string sym=OrderSymbol();
        RefreshRates();                                      //  
 if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(sym,MODE_ASK),slippage);
 if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(sym,MODE_BID),slippage);
 if(OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket()); 
 if(OrderType()==OP_BUYSTOP) OrderDelete(OrderTicket());
 }
 }
}

 
void startcLOSE() {
  int iOrders=OrdersTotal()-1, i;
  
  if(CloseOpenOrders) {
    for(i=iOrders; i>=0; i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && (OrderType()<=OP_SELL) && GetMarketInfo() && !OrderClose(OrderTicket(),OrderLots(),Price[1-OrderType()],giSlippage)) Print(OrderError());
    }
  }
}
//+------------------------------------------------------------------+
//| Function..: OrderError                                           |
//+------------------------------------------------------------------+
string OrderError() {
  int iError=GetLastError();
  return(StringConcatenate("Order:",OrderTicket()," GetLastError()=",iError," ",ErrorDescription(iError)));
}
//+------------------------------------------------------------------+
//| Function..: GetMarketInfo                                        |
//+------------------------------------------------------------------+
bool GetMarketInfo() {
  RefreshRates();
  Price[0]=MarketInfo(OrderSymbol(),MODE_ASK);
  Price[1]=MarketInfo(OrderSymbol(),MODE_BID);
  double dPoint=MarketInfo(OrderSymbol(),MODE_POINT);
  if(dPoint==0) return(false);
  giSlippage=(Price[0]-Price[1])/dPoint;
  return(Price[0]>0.0 && Price[1]>0.0);
}
//+------------------------------------------------------------------+

void Stamp(){

   ObjectCreate("Original", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Original", " ---http://Expforex.at.ua---", 10, "Arial Bold", Red);
   ObjectSet("Original", OBJPROP_CORNER, 2);
   ObjectSet("Original", OBJPROP_XDISTANCE, 200);
   ObjectSet("Original", OBJPROP_YDISTANCE, 10);


}